> For the complete documentation index, see [llms.txt](https://docs.oidc-spa.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.oidc-spa.dev/docs/v7/setup-guides/multi-providers.md).

# Multi Providers - Login with Google or Microsoft

{% hint style="warning" %}
This approach is discouraged.

Instead of managing multiple authentication providers within your application, consider using [Keycloak](https://www.keycloak.org/) or [Auth0](https://auth0.com/) to streamline and centralize identity provider integration.
{% endhint %}

The example setup is live here: [https://example-multi-providers.oidc-spa.dev/](https://example-multi-providers.oidc-spa.dev)

Run it locally with:

```bash
npx degit https://github.com/keycloakify/oidc-spa/examples/multi-providers oidc-spa-multi-providers
cd oidc-spa-multi-providers
# NOTE: With this example only internat Insee Microsoft account can sign in.
# You can however signin with your personal Google Account.
cp .env.local.sample .env.local
yarn
yarn dev
```

{% embed url="<https://github.com/keycloakify/oidc-spa/tree/main/examples/multi-providers>" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.oidc-spa.dev/docs/v7/setup-guides/multi-providers.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
